package cn.net.cpzslibs.prot.handset;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.Prot10057ChuKuNewWineResult;
import cn.net.cpzslibs.prot.handset.bean.Prot10057SendBeanNewWine;
import cn.net.cpzslibs.prot.utils.StrUtils;

public class Prot10057ChuKuNewWine extends ProtBase {
	/**
	 * 是否成功
	 */
	private short iResult;

	private final short iTaskCode10057 = 10057;

	private Gson gson;
	
	public Prot10057ChuKuNewWine(){
		gson = new Gson();
	}
	
	
	private Prot10057ChuKuNewWineResult res;

	public Prot10057ChuKuNewWineResult getRes() {
		return res;
	}

	public void setRes(Prot10057ChuKuNewWineResult res) {
		this.res = res;
	}

	public void dealChuKuNewWine(SocketCreate create,
                                 Prot10057SendBeanNewWine chukuBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), chukuBean);
	}

	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot10057SendBeanNewWine chukuBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				// 发送登录信息
				debugLog(iTaskCode10057, "开始发送出库信息");
				sendProt(dos, chukuBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}

	/**
	 * 读取JSon数据
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode10057, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode10057, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			res = gson.fromJson(jsonData, Prot10057ChuKuNewWineResult.class);
		}
		recCheckCode(dis);
	}

	
	/**
	 * 发送JSon数据到服务器
	 * 
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos,
			Prot10057SendBeanNewWine chukuBean) throws IOException {
		System.out.println("---bodyContent之前"+chukuBean);
		
		String bodyContent = gson.toJson(chukuBean).toString();
		
		System.out.println("---bodyContent之后"+bodyContent);
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode10057, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
		
		sendCheckCoded(dos, bodyContent.getBytes("UTF-8"));
	}
}

